		radix	DEC
		LIST	P=18F252
		include	"p18f252.inc"

		cblock	0x10
			t_cur
			t_old
			t_tmp
			count
			timer_stop			
			timer_counts
		endc

		org	0x0000
		goto	start
		org	0x0008
		goto	isr_timer
		org	0x0020

		include	"../global.inc"

start:		clrf	PORTA
		clrf	LATA
		movlw	0x07
		movwf	ADCON1
		bsf	TRISA,5
		
		call	init_serial
		call	init_timer

init:		clrf	count		;rpm count
		clrf	t_cur
		clrf	timer_stop	;stop flag
		movlf	timer_counts,7
		bsf	T1CON,TMR1ON	;turn on Timer1
loop:		btfss	timer_stop,1
		bra	next
		bcf	T1CON,TMR1ON	;turn off Timer1
		SER_TXf	count
		bra	init

next:		movff	t_cur,t_old
		movff	PORTA,t_cur
		movff	t_cur,t_tmp
		movf	t_old,W
		xorwf	t_tmp,F
		btfss	t_tmp,5
		bra	loop
		incf	count,F
		bra	loop		

init_timer:	bcf	PIR1,TMR1IF	;clear the Timer1 interrupt flag
		bsf	PIE1,TMR1IE	;enable Timer1 interrupts
		bsf	INTCON,GIEH	;set the global interrupt enable bits
		bsf	INTCON,GIEL
		clrf	T1CON		; setup the timer1
		clrf	TMR1H
		clrf	TMR1L
		return

isr_timer:	bcf	PIR1,TMR1IF	;Clear the Timer1 interrupt flag.
		decfsz	timer_counts,f
		retfie
		bsf	timer_stop,1
		retfie

		END
