		radix	DEC
		LIST	P=18F252
		include	"p18f252.inc"
		cblock	0
			TR
			DATA1
			DATA2
			DATA3
			dt0
			dt1		
			dt2
		endc
		
DEV_NUMBER	equ	0x07		
		
Fosc		equ	20000000
SBaud		equ	    9600
IBaud		equ	  100000
BASE_ADDR	equ	0x48
LM75_READ	equ	(((DEV_NUMBER | BASE_ADDR) << 1) | 1)
;-----------------------------------------------------------------------
		org	0x00000
		goto	start
;-----------------------------------------------------------------------		
		org	0x00020
I2C_TXc	macro	x
		movlw	x
		movwf	TR
		call	i2c_send
	endm
I2C_RXf	macro	fx
		call	i2c_read
		movff	TR,fx
	endm
I2C0	macro
		bcf	PIR1,SSPIF
	endm
I2C1	macro
		btfss	PIR1,SSPIF
		goto	$-2
	endm
init_i2c:	bsf	PORTC, 3
		bsf	PORTC, 4
		bsf	TRISC, SCL
		bsf	TRISC, SDA
		movlw	0x28		; MASTER
		movwf	SSPCON1
		clrf	SSPCON2
		movlw	((Fosc / (4 * IBaud)) - 1)
		movwf	SSPADD
		bsf	SSPSTAT,CKE	; 0 - I2C, 1 - SMB
		bsf	SSPSTAT,SMP	; 1 - turn off front length control
		return
		
i2c_start: 	I2C0
		bsf	SSPCON2,SEN
		I2C1
		return

i2c_restart:	I2C0
		bsf	SSPCON2,RSEN
		I2C1
		return
		
i2c_stop: 	I2C0
		bsf	SSPCON2,PEN
		I2C1
		return

i2c_send:	I2C0
		movff	TR,SSPBUF
		I2C1
		btfss	SSPCON2,ACKSTAT	; was ACK received from slave?
		return			; yes, return to calling routine
		call	i2c_restart
		bra	i2c_send	; send slave address again

i2c_read:	bsf	SSPCON2,RCEN	; enable receive mode
		I2C0
		I2C1
		movff	SSPBUF,TR
		bcf	SSPCON2,RCEN	; disable receive mode
		call	i2c_sack
		return

i2c_sack:	I2C0
		bsf	SSPCON2,ACKDT	; no ACK
		bsf	SSPCON2,ACKEN	; send ACKDT bit
		I2C1
		return		
;
delay_100ms	movlw	10
		movwf	dt2
d0:		movlw	(Fosc / 100000)
		movwf	dt1
d1:		movlw	62
		movwf	dt0
d2:		decf	dt0,f
		btfss	STATUS,Z
		goto	d2
		decfsz	dt1,f
		goto	d1
		decfsz	dt2,f
		goto	d0
		return
;-----------------------------------------------------------------------
SER_TXc	macro	x
		movlw	x
		movwf	TXREG
		call	delay_100ms
	endm
SER_TXf	macro	x
		movff	x,TXREG
		call	delay_100ms
	endm

init_serial:	movlw	b'00100100'
		movwf	TXSTA
		movlw	(Fosc / (16 * SBaud))
		movwf	SPBRG
		movlw	b'10010000'
		movwf	RCSTA
		return
;=======================================================================		
start:		call	init_serial
		call	init_i2c

main:		SER_TXc	0x55
		SER_TXc	0xAA

		call	i2c_start
		I2C_TXc	LM75_READ
		I2C_RXf	DATA1
		I2C_RXf	DATA2
		call	i2c_stop
	
		SER_TXf	DATA1
		SER_TXf	DATA2	
		goto	main
		END
